SystemOrganization addCategory: #MemoryMentor!
SystemOrganization addCategory: #'MemoryMentor-Tests'!

Morph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:37:29.698'!
initialize
	super initialize.
	self color: Color yellow.
	self
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:45:50.04'!
setupMemory: aMemory
	memory := aMemory.
	memory cellsDo: [ :cell |
		self addMorph: (MMMemoryCellMorph  for: cell)
	]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:38:58.14'!
intAt: index
	| word |
	<primitive: 165>
	word := self basicAt: index.
	word < 16r3FFFFFFF ifTrue:[^word]. "Avoid LargeInteger computations"
	^word >= 16r80000000	"Negative?!!"
		ifTrue:["word - 16r100000000"
				(word bitInvert32 + 1) negated]
		ifFalse:[word]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:44:13.346'!
intAt: index put: anInteger
	| word |
	<primitive: 166>
	anInteger < 0
		ifTrue:[anInteger < -16r80000000 ifTrue: [self error: anInteger asString , ' out of range'].
				"word := 16r100000000 + anInteger"
				word := (anInteger + 1) negated bitInvert32]
		ifFalse:[anInteger > 16r7FFFFFFF ifTrue: [self error: anInteger asString , ' out of range'].
				word := anInteger].
	self  basicAt: index put: word.
	^anInteger! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAdress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:01:36.45'!
from: startAdress size: byteSize
	^ self new
		initializeWithStartAdress: startAdress andByteSize: byteSize;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:42:20.88'!
at: adress putByte: byte
	memory byteAt: (self indexForAdress: adress) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:46:36.05'!
at: adress putInt: int
	memory intAt: (self indexForAdress: adress) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:30:32.702'!
byteAt: adress
	 ^ memory at: (self indexForAdress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:57:48.094'!
cellAtAdress: adress
	^ cells at: (self cellIndexForAdress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:57:18.038'!
cellIndexForAdress: adress
	^ ((adress roundDownTo: 4) - startAdress)/4 + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:30:26.288'!
indexForAdress: adress
	^ adress - startAdress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:43:12.658'!
initializeWithStartAdress: adress andByteSize: size
	startAdress := adress.
	memory := ByteArray new: size.
	cells := OrderedCollection new.
	1 to: size/4 do: [ :i |
		cells add: (MMMemoryCell at: (4*(i-1) + startAdress) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:39:53.016'!
intAt: adress
	 ^ memory intAt: (self indexForAdress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:18.3'!
startAdress
	^ startAdress! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'adress memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:47:37.946'!
at: adress in: memory
	 ^ self new
		initializeWithAdress: adress andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:18:52.68'!
adress
	^ adress! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:46:31.62'!
initializeWithAdress: anAdress andMemory: aMemory
	adress := anAdress.
	memory := aMemory! !

TestCase subclass: #MMMemoryTest
	instanceVariableNames: 'startAdress size memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:02:17.606'!
setUp
	startAdress := 16r1000.
	size := 100.
	memory := MMMemory from: startAdress size: size.! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:04:28.08'!
testCellAccess
	self shouldnt: [ memory cellAtAdress: startAdress + 8 ] raise: Exception.
	self assert: [ (memory cellAtAdress: startAdress + 8) adress == (startAdress + 8) ].
	
	self shouldnt: [ memory cellAtAdress: startAdress + 40 ] raise: Exception.
	self assert: [ (memory cellAtAdress: startAdress + 40) adress == (startAdress + 40) ].
	
	self shouldnt: [ memory cellAtAdress: startAdress + 96 ] raise: Exception.
	self assert: [ (memory cellAtAdress: startAdress + 96) adress == (startAdress + 96) ].
	
	self should: [ memory cellAtAdress: startAdress - 4 ] raise: Exception.
	
	self should: [ memory cellAtAdress: startAdress + 100 ] raise: Exception
! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:03:07.706'!
testCellIteration
	| cellIndex |
	cellIndex := 0.
	
	memory cellsDo: [ :cell |
		self assert: [ cell adress == (4*cellIndex + startAdress) ].
		cellIndex := cellIndex + 1
	].
	
	self assert: [ cellIndex == (size // 4) ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:02:36.664'!
testInitialization
	self assert: [ memory startAdress == startAdress ].
	self assert: [ memory byteSize == size ]! !

BorderedMorph subclass: #MMMemoryCellMorph
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCellMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:43:55.154'!
for: cell
	^ self new
		setupCell: cell;
		yourself! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:49:12.662'!
initialize 
	super initialize.
	self extent: 140@18.
	self color: Color yellow.
	self
		layoutPolicy: TableLayout new;
		"hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;"
		listDirection: #leftToRight;
		listCentering: #center! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:54:32.582'!
setupCell: cell
	4 timesRepeat: [
		self addMorph: (BorderedMorph new extent: 10@10; color: Color green; yourself)	
	].
	self addMorph: (StringMorph new contents: 'foobar'; yourself).! !
